﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Tools;

namespace Docking_Manager
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            
            this.dockingManager1.NewDockStateEndLoad += new EventHandler(dockingManager1_NewDockStateEndLoad);
            this.dockingManager1.DockStateChanging += new Syncfusion.Windows.Forms.Tools.DockStateChangeEventHandler(dockingManager1_DockStateChanging);
            AddCaptionButtons(gradientPanel1);
            SetDefaultView();
        }

        private void SetDefaultView()
        {
            dockingManager1.SetDockVisibility(gradientPanel1, true);
            dockingManager1.DockControl(gradientPanel1, this, DockingStyle.Top, 10);
            //dockingManager1.SetFloatOnly(gradientPanel1, true);
            ///
            ///Due to following lines double click event is not firing. Why?
            ///
            DockHost dockHostGen = gradientPanel1.Parent as DockHost;
            FloatingForm floatFormGen = dockHostGen.ParentForm as FloatingForm;
            if (floatFormGen == null)
            {
                return;
            }

            floatFormGen.Size = new Size(200, 200);
            floatFormGen.Location = this.PointToScreen(this.ClientRectangle.Location);
            ///
            ///
            ///
            
        }

        private void AddCaptionButtons(GradientPanel panel)
        {
            Syncfusion.Windows.Forms.Tools.CaptionButton minimizeButton = null;

            minimizeButton = new Syncfusion.Windows.Forms.Tools.CaptionButton();
            minimizeButton.ImageIndex = 1;
            minimizeButton.Type = CaptionButtonType.Custom;
            minimizeButton.TransparentImageColor = System.Drawing.Color.Transparent;
            minimizeButton.ToolTip = "Minimize";

            Syncfusion.Windows.Forms.Tools.ToolTipInfo objToolTipInfoMin = new Syncfusion.Windows.Forms.Tools.ToolTipInfo();
            Syncfusion.Windows.Forms.Tools.ToolTipInfo objToolTipInfoMax = new Syncfusion.Windows.Forms.Tools.ToolTipInfo();

            objToolTipInfoMin.BackColor = System.Drawing.Color.PeachPuff;
            objToolTipInfoMin.Header.Text = "Minimize";
            objToolTipInfoMin.Header.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            minimizeButton.SuperToolTipInfo = objToolTipInfoMin;

            minimizeButton.Name = panel.Name;
            minimizeButton.Click += new CancelEventHandler(MinimizeButton_Click);
            CaptionButtonsCollection captionButtonColl = new CaptionButtonsCollection();

            captionButtonColl.Add(minimizeButton);
            this.dockingManager1.SetCustomCaptionButtons(panel, captionButtonColl);
            //this.dockingManager1.EnableDoubleClickOnCaption = false;
            //this.dockingManager1.ControlMaximizing += new ControlMaximizeEventHandler(dockingManager1_ControlMaximizing);
        }

        void dockingManager1_ControlMaximizing(object sender, ControlMaximizeEventArgs args)
        {
            
        }

        void dockHostGen_MouseDown(object sender, MouseEventArgs e)
        {
            
        }

        

        void dockingManager1_DockStateChanging(object sender, Syncfusion.Windows.Forms.Tools.DockStateChangeEventArgs arg)
        {
            if (this.dockingManager1.IsFloating(arg.Controls[0]))
            {
                // Funtions can be performed here
            }
        }

        void dockingManager1_NewDockStateEndLoad(object sender, EventArgs e)
        {
//            dockingManager1.FloatControl(this.panel1, this.panel1.ClientRectangle);
        
        }

        void dockHostGen_MouseUp(object sender, MouseEventArgs e)
        {
            
        }

        private void dockingManager1_DockStateChanged(object sender, Syncfusion.Windows.Forms.Tools.DockStateChangeEventArgs arg)
        {
            if (this.dockingManager1.IsFloating(arg.Controls[0]))
            {
                // Funtions can be performed here

            }
            else
            {
                this.dockingManager1.FloatControl(this.gradientPanel1, this.DisplayRectangle);
                this.dockingManager1.SetControlSize(this.gradientPanel1, new Size(this.gradientPanel1.Size.Width + 200, this.gradientPanel1.Size.Height + 200));
                Rectangle workingArea = Screen.GetWorkingArea(this);
                DockHost dockHostGen = gradientPanel1.Parent as DockHost;
                FloatingForm floatFormGen = dockHostGen.ParentForm as FloatingForm;
                if (floatFormGen != null)
                {
                    floatFormGen.Location = new Point(0, workingArea.Bottom - Size.Height);
                }
            }
        }

        private void dockingManager1_DockContextMenu(object sender, Syncfusion.Windows.Forms.Tools.DockContextMenuEventArgs arg)
        {
            arg.ContextMenu.ParentBarItem.Items.Clear();
        }

        private void dockingManager1_AutoHideAnimationStop(object sender, Syncfusion.Windows.Forms.Tools.AutoHideAnimationEventArgs arg)
        {

        }

        private void dockingManager1_DockVisibilityChanged(object sender, Syncfusion.Windows.Forms.Tools.DockVisibilityChangedEventArgs arg)
        {

        }
        private void MinimizeButton_Click(object sender, CancelEventArgs e)
        {
        }
    }
}
